/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/dist/";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ({

/***/ "./js/src/Menu.js":
/*!************************!*\
  !*** ./js/src/Menu.js ***!
  \************************/
/*! exports provided: SlideMenu, AccordionMenu */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SlideMenu", function() { return SlideMenu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AccordionMenu", function() { return AccordionMenu; });
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var $ = jQuery;

function whichTransitionEvent() {
  var t;
  var el = document.createElement('fakeelement');
  var animEndEventNames = {
    'WebkitAnimation': 'webkitAnimationEnd',
    'OAnimation': 'oAnimationEnd',
    'msAnimation': 'MSAnimationEnd',
    'animation': 'animationend'
  };

  for (t in animEndEventNames) {
    if (el.style[t] !== undefined) {
      return animEndEventNames[t];
    }
  }
}

function onEndAnimation(el, callback) {
  var animationEvent = whichTransitionEvent();

  var onEndCallbackFn = function onEndCallbackFn(ev) {
    if (ev.target != this) {
      return;
    }

    this.removeEventListener(animationEvent, onEndCallbackFn);

    if (callback && typeof callback === 'function') {
      callback.call();
    }
  };

  el.addEventListener(animationEvent, onEndCallbackFn);
}

;

var SlideMenu =
/*#__PURE__*/
function () {
  function SlideMenu(options) {
    _classCallCheck(this, SlideMenu);

    this.options = Object.assign(this.defaults, options);
    this.$el = this.options.el;
    this.menus = this.$el.find(".".concat(this.options.classes.level));
    this.links = this.$el.find(".".concat(this.options.classes.link));
    this.nav = this.$el.find(".".concat(this.options.classes.nav));
    this.activeTree = [{
      name: 'All',
      link: 'main'
    }];
    var $current = $('[data-menu="main"]').addClass("".concat(this.options.classes.level, "--current"));
    $(".".concat(this.options.classes.wrap)).height($current.height());
    this.clickListener();
    this.addNavHandler();
  }

  _createClass(SlideMenu, [{
    key: "clickListener",
    value: function clickListener() {
      var self = this;
      this.links.click(function (e) {
        if (self.isAnimating) {
          return false;
        }

        var $clicked = $(this);
        var $level = $clicked.closest(".".concat(self.options.classes.level));
        var pos = $level.find('.menu__link').index($clicked);
        var submenu = $clicked.attr('data-submenu');
        var $submenu = $("[data-menu='" + submenu + "']");
        var name = $clicked.text();

        if ($submenu.length) {
          e.preventDefault();
          self.isAnimating = true;
          self.slideOut(pos);
          self.slideIn($submenu, pos);
          self.updateTree(name, submenu);
        }
      });
    }
  }, {
    key: "slideOut",
    value: function slideOut(clickPosition) {
      var back = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var self = this;
      var $currentMenu = $(".".concat(this.options.classes.level, "--current"));
      var $menuItems = $currentMenu.find(".".concat(this.options.classes.item));
      $menuItems.each(function (index, item) {
        var delay = parseInt(Math.abs(clickPosition - index) * self.options.itemsDelayInterval) + 'ms';
        $(item).css({
          'WebkitAnimationDelay': delay,
          'animationDelay': delay
        });
      });

      if (!back) {
        $currentMenu.addClass(self.options.classes.AnimateOutLeft);
      } else {
        $currentMenu.addClass(self.options.classes.AnimateOutRight);
      }
    }
  }, {
    key: "slideIn",
    value: function slideIn($submenu, clickPosition) {
      var back = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var self = this;
      var $menuItems = $submenu.find(".".concat(this.options.classes.item));
      var menuItemsTotal = $menuItems.length;
      var $currentMenu = $(".".concat(this.options.classes.level, "--current"));
      $(".".concat(this.options.classes.wrap)).height($submenu.height());
      $menuItems.each(function (index, item) {
        var delay = parseInt(Math.abs(clickPosition - index) * self.options.itemsDelayInterval) + 'ms';
        $(item).css({
          'WebkitAnimationDelay': delay,
          'animationDelay': delay
        });
        var farthestIdx = clickPosition <= menuItemsTotal / 2 ? menuItemsTotal - 1 : 0;

        if (index === farthestIdx) {
          onEndAnimation(item, function () {
            if (!back) {
              $currentMenu.removeClass(self.options.classes.AnimateOutLeft);
              $submenu.removeClass(self.options.classes.AnimateInRight);
            } else {
              $currentMenu.removeClass(self.options.classes.AnimateOutRight);
              $submenu.removeClass(self.options.classes.AnimateInLeft);
            }

            $currentMenu.removeClass("".concat(self.options.classes.level, "--current"));
            $submenu.addClass("".concat(self.options.classes.level, "--current"));
            self.isAnimating = false;
          });
        }
      });

      if (!back) {
        $submenu.addClass(self.options.classes.AnimateInRight);
      } else {
        $submenu.addClass(self.options.classes.AnimateInLeft);
      }
    }
  }, {
    key: "addCrumb",
    value: function addCrumb(name, link) {
      this.activeTree.push({
        name: name,
        link: link
      });
      this.updateCrumbs();
    }
  }, {
    key: "updateTree",
    value: function updateTree(name, link) {
      this.activeTree.push({
        name: name,
        link: link
      });
      this.nav.attr('data-active-tree', this.activeTree.length - 1);
    }
  }, {
    key: "addNavHandler",
    value: function addNavHandler() {
      var self = this;
      self.nav.click(function (e) {
        if (self.isAnimating) {
          return false;
        }

        if (self.activeTree.length > 1) {
          var i = self.activeTree.length - 2;
          var $submenu = $('[data-menu="' + self.activeTree[i].link + '"]');
          self.isAnimating = true;
          self.slideOut(0, true);
          self.slideIn($submenu, 0, true);
          self.activeTree.length -= 1;
          self.nav.attr('data-active-tree', self.activeTree.length - 1);
        }
      });
    }
  }, {
    key: "updateCrumbs",
    value: function updateCrumbs() {
      var self = this;
      var $crumbs = $('.doghouse-menu__breadcrumbs');
      var html = this.activeTree.map(function (crumb) {
        var link = $('<a>').attr('data-crumbmenu', crumb.link).text(crumb.name);
        return link;
      });
      html.forEach(function (v, i) {
        $(v).click(function (e) {
          if (i == html.length - 1 || self.isAnimating) {
            return false;
          }

          self.activeTree.length = i + 1;
          var $submenu = $('[data-menu="' + self.activeTree[i].link + '"]');
          self.slideOut(0, true);
          self.slideIn($submenu, 0, true);
          self.updateCrumbs();
        });
      });
      $crumbs.html(html);
    }
  }]);

  return SlideMenu;
}();

SlideMenu.prototype.defaults = {
  itemsDelayInterval: 60,
  classes: {
    level: 'doghouse-menu__level',
    item: 'doghouse-menu__item',
    link: 'doghouse-menu__link',
    nav: 'doghouse-menu__nav',
    wrap: 'doghouse-menu__wrap',
    AnimateInLeft: 'doghouse-menu-animate--in-left',
    AnimateOutLeft: 'doghouse-menu-animate--out-left',
    AnimateInRight: 'doghouse-menu-animate--in-right',
    AnimateOutRight: 'doghouse-menu-animate--out-right'
  }
};

var AccordionMenu = function AccordionMenu(options) {
  _classCallCheck(this, AccordionMenu);

  this.options = Object.assign(this.defaults, options);
  this.$el = this.options.el;
  $('.toggle', this.$el).click(function (e) {
    $(this).toggleClass('open').next('.menu').slideToggle();
  });
};

AccordionMenu.prototype.defaults = {};


/***/ }),

/***/ "./js/src/doghouse-menu.js":
/*!*********************************!*\
  !*** ./js/src/doghouse-menu.js ***!
  \*********************************/
/*! no exports provided */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _Menu__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./Menu */ "./js/src/Menu.js");
/**
 * @file
 * Defines Javascript behaviors for the doghouse menu.
 */


(function ($, Drupal, drupalSettings) {
  Drupal.doghouseMenu = Drupal.doghouseMenu || [];
  /**
   * Behaviors for summaries for tabs in the media edit form.
   *
   * @type {Drupal~behavior}
   *
   * @prop {Drupal~behaviorAttach} attach
   *   Attaches summary behavior for tabs in the media edit form.
   */

  Drupal.behaviors.doghouseMenu = {
    attach: function attach(context) {
      $('.js-doghouse-menu', context).once('doghouse-menu').doghouseMenu();
    }
  };

  $.fn.doghouseMenu = function () {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    return this.each(function (i, v) {
      options.el = $(v);

      switch (options.el.attr('data-menu-type')) {
        case 'slide':
          Drupal.doghouseMenu.push(new _Menu__WEBPACK_IMPORTED_MODULE_0__["SlideMenu"](options));
          break;

        case 'accordion':
          Drupal.doghouseMenu.push(new _Menu__WEBPACK_IMPORTED_MODULE_0__["AccordionMenu"](options));
          break;
      }
    });
  };
})(jQuery, Drupal, drupalSettings);

/***/ }),

/***/ 0:
/*!***************************************!*\
  !*** multi ./js/src/doghouse-menu.js ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(/*! /Users/cbradshaw/Sites/dhhs/docroot/modules/custom/doghouse_menu/js/src/doghouse-menu.js */"./js/src/doghouse-menu.js");


/***/ })

/******/ });
//# sourceMappingURL=doghouse-menu.js.map